/*
 * parse.h
 */

struct param {
    int len;
    char *s;
};

void parse();
int brace_balance();
int parse_walk();
void study_action_pattern();
int search_action();
int escape_specials();
void escape_command();
void unescape();
void escape_seq();
void unescape_seq();
int get_token();
char *chop_arg();
char *chop_str();
char *skipnum();

#ifdef __GNUC__
#define skipspace(s) _skipspace(s)
extern char *_skipspace();
extern __inline char *_skipspace(s)
char *s;
{
    char *p = s - 1;
    do p++; while(*p == ' ');
    return p;
}
#else
char *skipspace();
#endif

/* assuming standard ASCII charset */
#define ctoi(c) ((unsigned char)(c) - '0')

#ifdef OWN_CTYPE
extern const unsigned char ct_array[256];
#undef isprint
#undef isgraph
#undef isalpha
#undef isdigit
#define C_TYPE(c) (ct_array[(unsigned char)(c)])
#define isgraph(c) (C_TYPE(c) & 0x01)
#define isprint(c) (C_TYPE(c) & 0x41)
#define isalpha(c) (C_TYPE(c) & 0x02)
#define isdigit(c) (C_TYPE(c) & 0x04)
#define islabel(c) (C_TYPE(c) & 0x0e)
#define isrparen(c) (C_TYPE(c) & 0x10)
#define islparen(c) (C_TYPE(c) & 0x20)
#else
#define islabel(c) (isalnum((c)) || (char)(c) == '_')
#define isrparen(c) ((char)(c) == ')' || (char)(c) == ']' || (char)(c) == '}')
#define islparen(c) ((char)(c) == '(' || (char)(c) == '[' || (char)(c) == '{')
#endif

#define LRPARENS(a, b)					\
	(((char)(a) == '(' && (char)(b) == ')') ||	\
	 ((char)(a) == '[' && (char)(b) == ']') ||	\
	 ((char)(a) == '{' && (char)(b) == '}'))

